// Written by Fred from DBA.
// Updated by Julien Muchembled.
// Copyright (c) 1998-2000. All rights reserved.

// Built with Turbo C++ 3.0 for DOS
// Memory model : compact

#include <dos.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#define DEFAULT_PORT 0x378
#define PAUSE        0
#define INIT_DELAY   500

#define FALSE 0
#define TRUE  1

#define min(a,b)    (((a) < (b)) ? (a) : (b))

unsigned char Bits[] = {1, 2, 4, 8, 16, 32, 64, 128};
unsigned int IN_PORT, OUT_PORT;

long fsize(FILE *stream)
{
	long curpos, length;

	curpos = ftell(stream);
	fseek(stream, 0L, SEEK_END);
	length = ftell(stream);
	fseek(stream, curpos, SEEK_SET);
	return length;
}

void Wait ()
{
	delay(PAUSE);
//	delay(PAUSE);
}

void Wait1 (unsigned char mask)
{
	while(inportb(IN_PORT) & mask);
}

void Wait2 (unsigned char mask)
{
	while(!(inportb(IN_PORT) & mask));
}

unsigned char sendTI92(unsigned char Octet)
{
	int i;

	for(i = 0; i <= 7; i++)	{
		if(Octet & Bits[i]) {
			outportb(OUT_PORT, 2); Wait1 (0x10);
			outportb(OUT_PORT, 3); Wait2 (0x10);
		}	else {
			outportb(OUT_PORT, 1); Wait1 (0x20);
			outportb(OUT_PORT, 3); Wait2 (0x20);
		}
		Wait ();
	}
	return Octet;
}

unsigned char getTI92()
{
	unsigned char byte = 0;
	int i, j;

	for(i = 0; i <= 7; i++) {
		while((inportb(IN_PORT) & 0x30) == 0x30);
		if((inportb(IN_PORT) & 0x30) == 0x10) {
			byte += Bits[i];
			outportb(OUT_PORT, 1);
			while((inportb(IN_PORT) & 0x20) == 0x00);
			outportb(OUT_PORT, 3);
		}	else {
			outportb(OUT_PORT, 2);
			while((inportb(IN_PORT) & 0x10) == 0x00);
			outportb(OUT_PORT, 3);
		}
		Wait ();
	}
	return byte;
}


void main(int argc, char ** argv)
{
	char *Buffer1 = (char *) malloc(32765);
	if (!Buffer1) return;
	char *Buffer2 = (char *) malloc(32765);
	if (!Buffer2) { free ((void *) Buffer1); return; }

	FILE * InFile;
	int Continue;
	unsigned int CheckSum;
	unsigned char CalcType;
	long NbLu, i, toWrite, FileSize;

	if((InFile = fopen(argv[1], "rb")) == NULL)
	{
		printf("Erreur : file not found !\n");
		printf("Usage : SENDFLSH <filename> [<port>]\n");
		printf("        Default port is 0x%x\n", DEFAULT_PORT);
		goto OnExit;
	}
	FileSize = fsize(InFile);
	fread((void*)Buffer1, 1, 0x90, InFile);
	CalcType = Buffer1[0x88] & 0x20 ? 0x18 : 8;
	fseek(InFile, 0, SEEK_SET);

	if(argc == 3)	{
		OUT_PORT = strtol(argv[2], (void *)0, 0);
		IN_PORT = OUT_PORT + 1;
	}	else {
		OUT_PORT = DEFAULT_PORT;
		IN_PORT = OUT_PORT + 1;
	}
	printf("Using port : 0x%x\n", OUT_PORT);
	outportb(OUT_PORT, 3);
	delay(INIT_DELAY);

	sendTI92(0x00);
	sendTI92(0x68);
	sendTI92(0x00);
	sendTI92(0x00);

	getTI92();
	getTI92();
	getTI92();
	getTI92();

	sendTI92(CalcType);
	sendTI92(0x68);
	sendTI92(0x00);
	sendTI92(0x00);

	getTI92();
	getTI92();
	getTI92();
	getTI92();

	CheckSum = 0;
	sendTI92(CalcType);
	sendTI92(0xC9);
	sendTI92(0x06);
	sendTI92(0x00);
	i = FileSize & 0xFF;
	CheckSum += i;
	sendTI92(i);
	i = (FileSize >> 8) & 0xFF;
	CheckSum += i;
	sendTI92(i);
	i = (FileSize >> 16) & 0xFF;
	CheckSum += i;
	sendTI92(i);
	sendTI92(0x00);
	sendTI92(0x23);
	sendTI92(0x00);
	CheckSum += 0x23;
	sendTI92(CheckSum & 0xFF);
	sendTI92((CheckSum >> 8) & 0xFF);

	getTI92();
	getTI92();
	getTI92();
	getTI92();
	getTI92();
	getTI92();
	getTI92();
	getTI92();

	sendTI92(CalcType|=0x80);
	sendTI92(0x56);
	sendTI92(0x00);
	sendTI92(0x00);

	Continue = TRUE;
	while(Continue) {
		CheckSum = 0;
		NbLu = fread((void*)Buffer1, 1, 32765, InFile);
		NbLu += fread((void*)Buffer2, 1, 32765, InFile);
		if(NbLu != 65530) Continue = FALSE;
		sendTI92(CalcType);
		sendTI92(0x15);
		sendTI92(NbLu & 0xFF);
		sendTI92((NbLu >> 8) & 0xFF);
		toWrite = min(32765,NbLu);
		for(i = 0 ; i < toWrite ; i++) {
			sendTI92(Buffer1[i]);
			CheckSum += (unsigned char)Buffer1[i];
			if(i % 1024) {
				printf("%d/64", i / 1024);
				gotoxy(1, wherey());
		}	}
		if(NbLu > 32765) {
			toWrite = NbLu - 32765;
			for(i = 0 ; i < toWrite ; i++) {
				sendTI92(Buffer2[i]);
				CheckSum += (unsigned char)Buffer2[i];
				if(i % 1024) {
					printf("%d/64", i / 1024 + 32);
					gotoxy(1, wherey());
		}	}	}
		printf("\n");

		sendTI92(CheckSum & 0xFF);
		sendTI92((CheckSum >> 8) & 0xFF);

		getTI92();
		getTI92();
		getTI92();
		getTI92();

		if(Continue == FALSE) {
			sendTI92(CalcType);
			sendTI92(0x92);
			sendTI92(0x00);
			sendTI92(0x00);

			getTI92();
			getTI92();
			getTI92();
			getTI92();
			break;
		}

		sendTI92(CalcType);
		sendTI92(0x78);
		sendTI92(0x00);
		sendTI92(0x00);

		getTI92();
		getTI92();
		getTI92();
		getTI92();
		getTI92();
		getTI92();
		getTI92();
		getTI92();

		sendTI92(CalcType);
		sendTI92(0x56);
		sendTI92(0x00);
		sendTI92(0x00);

//	while(!kbhit()) printf("%X\n", getTI92());
	}
	fclose (InFile);
OnExit:
	free ((void *) Buffer1);
	free ((void *) Buffer2);
}